# Clase lista doblemente enlazadada
# @author alu0100891447
# @attr [Node] head Primer nodo de la lista
# @attr [Node] tail Ultimo nodo de la lista

class Lista
    include Enumerable
    attr_accessor :head, :tail
    Node=Struct.new(:value,:next, :prev)
    class Node
        undef value=, next=, prev=
    end
# Ejecuta el bloque de codigo para cada elemento
# @return [void]
    def each
        actual = @head
        while actual do
            yield(actual[:value])
            actual = actual[:next]
        end
    end

# Crea una instacia de lista
# @param [Node] head Primer nodo de la lista
# @param [Node] tail Ultimo nodo de la lista
    def initialize()
        @head = nil
        @tail = nil
    end

# Inserta un elemento por el frente, pasandole el valor, y creandolo el nodo que lo contiene dentro de la funcion
# @param [Valor] elemento Valor a insertar en la lista
# @return [void]
    def insert(elemento)

        x = Node.new(elemento, @head, nil)

        if(!@head)
            @head = x
            @tail = x
        else
            @head[:prev] = x
            @head = x
        end

    end

# Inserta un elemento por detras, pasandole el valor, y creandolo el nodo que lo contiene dentro de la funcion
# @param [Valor] elemento Valor a insertar en la lista
# @return [void]
    def insert_back(elemento)
        x = Node.new(elemento, nil, @tail)

        if(!@tail)
            @head = x
            @tail = x
        else
            @tail[:next] = x
            @tail = x

        end

    end

# Extraer un elemento de la lista por el frente
# @return [number] Valor del nodo extraido de la lista
    def extract()
        if (@head)
            aux = @head[:value]
            @head = @head[:next];
            if(!@head)
                @tail = nil
            else
                @head[:prev] = nil
            end
            aux
        end
    end

# Extraer un elemento de la lista por detras
# @return [number] Valor del nodo extraido de la lista
    def extract_back()
        if(@tail)
            aux = @tail[:value]
            @tail = @tail[:prev]
            if(!@tail)
                @head = nil
            else
                @tail[:next] = nil
            end
            aux
        end
    end

# Funcion para mostrar los datos en forma de cadena
# @return [String] Cadena que contiene la salida formateada
    def to_s
        i=1
        aux=@head
        show=""
        while (aux)
            if(aux[:value].is_a?Lista)
                show+= "Dieta numero #{i} de la semana\n"
            else
                show+= "#{i})"
            end
            show += " #{aux[:value].to_s}\n"
            aux = aux[:next]
            i +=1
        end
        show
    end
end
